/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__ANSWER_H__INCLUDED__)
#define __NDD__ANSWER_H__INCLUDED__

#include <ndd/defs.h>

/*  ׶֣Ĥɽǡ  */
struct __ndd_answer
{
    ndd_uint32 frame_offset_1;
    ndd_uint32 frame_offset_2;
    ndd_uint32 frame_count;
    ndd_uint32 segment_count;
    ndd_float8 distance_avg;
    ndd_float8 distance_min;
    ndd_float8 distance_max;
};

/*  ndd_answer ν  */
struct __ndd_answer_set
{
    ndd_uint32   answer_count;
    ndd_answer **answers;
};

extern ndd_result ndd_answer_create (ndd_answer **answer);
extern ndd_result ndd_answer_destroy(ndd_answer **answer);

extern ndd_result ndd_answer_set_create (ndd_answer_set **answer_set);
extern ndd_result ndd_answer_set_destroy(ndd_answer_set **answer_set);

#endif  /*  #if !defined(__NDD__ANSWER_H__INCLUDED__)  */

/*  end of file  */
