/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__ERROR_H__INCLUDED__)
#define __NDD__ERROR_H__INCLUDED__

#include <ndd/defs.h>

/*  Error Codes  */
#define NDD_SUCCESS                     0

/*  ǡ˴ؤ륨顼  */
#define NDD_ERROR_INVALID_POINTER       10001
#define NDD_ERROR_INVALID_PARAMETER     10002
#define NDD_ERROR_MATRIX_SIZE_MISMATCH  10003
#define NDD_ERROR_VECTOR_SIZE_MISMATCH  10004
#define NDD_ERROR_NOT_CONVERGED         10005
#define NDD_ERROR_DATA_ALREADY_EXISTS   10006
#define NDD_ERROR_FRAME_OFFSET_OUT_OF_BOUND   10007
#define NDD_ERROR_FRAME_COUNT_OUT_OF_BOUND    10008
#define NDD_ERROR_SEGMENT_OFFSET_OUT_OF_BOUND 10009
#define NDD_ERROR_SEGMENT_COUNT_OUT_OF_BOUND  10010
#define NDD_ERROR_SAME_DATA                   10011
#define NDD_ERROR_FRAME_DATA_NOT_CONTIGUOUS   10012
#define NDD_ERROR_SEGMENT_DATA_NOT_CONTIGUOUS 10013
#define NDD_ERROR_FRAME_INDEX_OUT_OF_BOUND    10014
#define NDD_ERROR_MPEG_HAS_NO_VIDEO_STREAM    10015
#define NDD_ERROR_MINIMUM_SEGMENT_SIZE_TOO_SMALL 10016

#define NDD_ERROR_SCREEN_SIZE_MISMATCH        10101
#define NDD_ERROR_REGION_POSITION_MISMATCH    10102
#define NDD_ERROR_REGION_SIZE_MISMATCH        10103
#define NDD_ERROR_BLOCK_SIZE_MISMATCH         10104
#define NDD_ERROR_COLOR_RESOLUTION_MISMATCH   10105
#define NDD_ERROR_FRAME_DIMENSION_MISMATCH    10106
#define NDD_ERROR_FRAME_SAMPLE_COUNT_MISMATCH 10107
#define NDD_ERROR_FRAME_SELECTOR_MISMATCH     10108
#define NDD_ERROR_SEGMENT_SIZE_MISMATCH         10109
#define NDD_ERROR_SEGMENT_DIMENSION_MISMATCH    10110
#define NDD_ERROR_SEGMENT_SAMPLE_COUNT_MISMATCH 10111
#define NDD_ERROR_SEGMENT_SELECTOR_MISMATCH     10112

/*  ˴ؤ륨顼  */
#define NDD_ERROR_ALLOCATION_FAILED 20001

/*  ե륢˴ؤ륨顼  */
#define NDD_ERROR_FILE_OPEN_FAILED  30001
#define NDD_ERROR_FILE_CLOSE_FAILED 30002
#define NDD_ERROR_FILE_READ_FAILED  30003
#define NDD_ERROR_FILE_WRITE_FAILED 30004
#define NDD_ERROR_FILE_SEEK_FAILED  30009
#define NDD_ERROR_MPEG_FILE_OPEN_FAILED  30005
#define NDD_ERROR_MPEG_FILE_CLOSE_FAILED 30006
#define NDD_ERROR_MPEG_FILE_READ_FAILED  30007
#define NDD_ERROR_INVALID_FILE_MODE      30008

#define NDD_ERROR_FILE_NOT_ASSIGNED 30010
#define NDD_ERROR_FILE_NOT_OPENED_TO_READ 30011
#define NDD_ERROR_FILE_NOT_OPENED_TO_WRITE 30012

/*  ץꥱͭΥ顼  */
#define NDD_ERROR_APPLICATION_ERROR 90001

#endif  /*  #if !defined(__NDD__ERROR_H__INCLUDED__)  */


/*  end of file  */
