/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__MATRIX_H__INCLUDED__)
#define __NDD__MATRIX_H__INCLUDED__

#include <ndd/defs.h>

struct __ndd_matrix
{
    ndd_uint32   row_count;
    ndd_uint32   column_count;
    ndd_float8 **data;  /*  data[column_index][row_index]  */
};

extern ndd_result ndd_matrix_create (ndd_matrix **matrix, ndd_uint32 column_count, ndd_uint32 row_count);
extern ndd_result ndd_matrix_destroy(ndd_matrix **matrix);

/*  column_index Υǡ񤭤  */
extern ndd_result ndd_matrix_set_column_data(ndd_matrix *matrix,
					     ndd_uint32 column_index, const ndd_float8 *values, ndd_uint32 size);

/*  column_index  row_index ܤΥǡ񤭤  */
extern ndd_result ndd_matrix_set_column_row_data(ndd_matrix *matrix,
						 ndd_uint32 column_index, ndd_uint32 row_index,
						 const ndd_float8 *values, ndd_uint32 size);

extern ndd_result ndd_matrix_get_column_data(const ndd_matrix *matrix,
					     ndd_uint32 column_index, ndd_float8 *values, ndd_uint32 size);
extern ndd_result ndd_matrix_swap_columns(ndd_matrix *matrix,
					  ndd_uint32 column_index_1, ndd_uint32 column_index_2);

#endif  /*  #if !defined(__NDD__MATRIX_H__INCLUDED__)  */

/*  end of file  */
