/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__MEMORY_H__INCLUDED__)
#define __NDD__MEMORY_H__INCLUDED__

#include <ndd/defs.h>
#include <ndd/types.h>

/*    */

#define ndd_malloc(p, size)   ndd_malloc_impl((void **)(p), (size))
#define ndd_calloc(p, size)   ndd_calloc_impl((void **)(p), (size))
#define ndd_realloc(p, size)  ndd_realloc_impl((void **)(p), (size))
#define ndd_free(p)           ndd_free_impl((void **)(p))

extern ndd_result ndd_malloc_impl (void **p, ndd_uint32 size);
extern ndd_result ndd_calloc_impl (void **p, ndd_uint32 size);
extern ndd_result ndd_realloc_impl(void **p, ndd_uint32 size);
extern ndd_result ndd_free_impl   (void **p);

#endif  /*  #if !defined(__NDD__MEMORY_H__INCLUDED__)  */

/*  end of file  */
