/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__MKFFD_H__INCLUDED__)
#define __NDD__MKFFD_H__INCLUDED__

#include <ndd/defs.h>
#include <ndd/callback.h>

/**
 *  @brief
 *  @a src_fvd ǻꤵ줿 FVD ǡ顢@a src_ffs ǻꤵ줿 
 *  FFS ǡѤ FFD ǡǡ@a dst_ffd ˳Ǽ
 *  롣
 *
 *
 *  Ѵ˻Ѥѥ᡼򡢤餫 @a src_fvd->header @a
 *  src_ffs->header  @a dst_ffd->header ˳Ǽ֤Ǵؿ
 *  ӽФɬפ롣
 *
 *   FVD ǡΥإå@a src_fvd->headerˤ˴ޤޤƥѥ᡼
 *  Τ˻ѤΤϲΤΤǤ롣
 *      region_width
 *      region_height
 *      block_width
 *      block_height
 *      frame_count
 *
 *   FFS ǡΥإå@a src_ffs->headerˤ˴ޤޤƥѥ᡼
 *  Τ˻ѤΤϲΤΤǤ롣
 *      frame_dimension
 *
 *  ¦ǡΥإå@a dst_ffd->headerˤ˴ޤޤƥѥ᡼
 *  ˻ѤΤϲΤΤǤ롣
 *      (ʤ)
 *
 *  ¦ǡΥإå@a dst_ffd->headerˤ˴ޤޤƥѥ᡼
 *  
 *      marker                  
 *      version                 
 *      _reserved1               FVD
 *      _reserved2               FVD
 *      screen_width             FVD
 *      screen_height            FVD
 *      region_left              FVD
 *      region_top               FVD
 *      region_width             FVD
 *      region_height            FVD
 *      block_width              FVD
 *      block_height             FVD
 *      color_resolution         FVD
 *      frame_sample_count       FFS
 *      frame_dimension          FFS
 *      frame_proportion         FFS
 *      segment_size             FVD
 *      segment_sample_count     FVD
 *      segment_dimension        FVD
 *      segment_proportion       FVD
 *      total_frame_count        FVD
 *      frame_offset             FVD
 *      frame_count              FVD
 *      minimum_segment_size     FVD
 *      rough_search_threshold   FVD
 *      fine_search_threshold    FVD
 *      _reserved3               FVD
 *      _reserved4               FVD
 *      _reserved5               FVD
 *      _reserved6               FVD
 *
 *  㡧
 *    ߡѲʤ
 *    η̤˱Ѳ
 *    @a src_fvd Ʊեɤͤԡ
 *    ͤ
 *
 *
 *  顼 NDD_ERROR_INVALID_PARAMETER Ȥʤ륱ϡ̤Ǥ
 *  롣
 *
 *  ToDo:
 *
 */
extern ndd_result ndd_create_ffd_from_fvd(ndd_ffd *dst_ffd,
					  ndd_fvd *src_fvd, const ndd_ffs *src_ffs,
					  ndd_callback callback, void *user_data);

#endif  /*  #if !defined(__NDD__MKFFD_H__INCLUDED__)  */

/*  end of file  */
