/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__MKFVD_H__INCLUDED__)
#define __NDD__MKFVD_H__INCLUDED__

#include <ndd/defs.h>
#include <ndd/callback.h>

/**
 *  @brief
 *  @a mpeg_file ǻꤵ줿 MPEG ե򳫤FVD ǡѴ
 *  ǡ@a dst_fvd ˳Ǽ롣
 *
 *  Ѵ˻Ѥѥ᡼򡢤餫 @a dst_fvd->header ˳Ǽ
 *  ֤ǴؿƤӽФɬפ롣
 *
 *  Ȥѥ᡼
 *    region_left
 *    region_top
 *    region_width    0 ξϡMPEG ե뤫Ѥ롣ޤƱ˾񤭤롣
 *    region_height   0 ξϡMPEG ե뤫Ѥ롣ޤƱ˾񤭤롣
 *    block_width
 *    block_height
 *
 *  ѹѥ᡼
 *    screen_width    MPEG ե뤫줿ͤѹ
 *    screen_height   MPEG ե뤫줿ͤѹ
 *
 */
extern ndd_result ndd_create_fvd_from_mpeg(ndd_fvd *dst_fvd, const char *mpeg_file,
					   ndd_callback callback, void *user_data);

#endif  /*  #if !defined(__NDD__MKFVD_H__INCLUDED__)  */

/*  end of file  */
