/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__MKSFS_H__INCLUDED__)
#define __NDD__MKSFS_H__INCLUDED__

#include <ndd/defs.h>
#include <ndd/callback.h>

/**
 *  @brief
 *  @a fvd ǻꤵ줿 FVD ǡ顢SFS ǡǡ@a
 *  dst_sfs ˳Ǽ롣
 *
 *
 *  Ѵ˻Ѥѥ᡼򡢤餫 @a src_fvd->header  
 *  @a dst_sfs->header ˳Ǽ֤ǴؿƤӽФɬפ롣
 *
 *  ǡΥإå@a src_fvd->headerˤ˴ޤޤƥѥ᡼
 *  ˻ѤΤϲΤΤǤ롣
 *      region_width
 *      region_height
 *      block_width
 *      block_height
 *
 *  ¦ǡΥإå@a dst_sfs->headerˤ˴ޤޤƥѥ᡼
 *  ˻ѤΤϲΤΤǤ롣
 *      frame_sample_count
 *      frame_dimension
 *      frame_proportion
 *
 *  ǡΤƬ frame_sample_count ĤǤѤƽ
 *  Ԥ
 *
 *  frame_dimension  frame_proportion ϡɤ餫Ĥ͡⤦
 *  Ĥ 0 ǤʤФʤʤͤȤʤäۤsfs ǡ
 *  ǿꤹѥ᡼ȤƻѤ롣
 *
 *
 *  ¦ǡΥإå@a dst_sfs->headerˤ˴ޤޤƥѥ᡼
 *  
 *      marker                  
 *      version                 
 *      _reserved1              
 *      _reserved2              
 *      screen_width            
 *      screen_height           
 *      region_left             
 *      region_top              
 *      region_width            
 *      region_height           
 *      block_width             
 *      block_height            
 *      color_resolution        
 *      frame_sample_count      
 *      frame_dimension         
 *      frame_proportion        
 *      segment_size            
 *      segment_sample_count    
 *      segment_dimension       
 *      segment_proportion      
 *      total_frame_count       
 *      frame_osfset            
 *      frame_count             
 *      minimum_segment_size    
 *      rough_search_threshold  
 *      fine_search_threshold   
 *      _reserved3              
 *      _reserved4              
 *      _reserved5              
 *      _reserved6              
 *
 *  㡧
 *    ߡѲʤ
 *    η̤˱Ѳ
 *    @a src_fvd Ʊեɤͤԡ
 *    ͤ
 *
 *
 *  顼 NDD_ERROR_INVALID_PARAMETER Ȥʤ륱ϡ̤Ǥ
 *  롣
 *
 *    dst_sfs ۲ frame_sample_count ͤsrc_fvd ۲ 
 *      elements_per_frame ͤ꾮
 *
 *    dst_sfs ۲ frame_sample_count ͤsrc_fvd ۲ 
 *      ե졼礭
 *
 *    dst_sfs ۲ frame_dimension ͤȡdst_sfs ۲ 
 *      frame_proportion ͤȤ 0 Ǥʤ
 *
 *    dst_sfs ۲ frame_dimension ͤȡdst_sfs ۲ 
 *      frame_proportion ͤȤ 0 Ǥ롣
 *
 */
extern ndd_result ndd_create_sfs_from_ffd(ndd_sfs *dst_sfs, const ndd_ffd *src_ffd, ndd_callback callback, void *user_data);

#endif  /*  #if !defined(__NDD__MKSFS_H__INCLUDED__)  */

/*  end of file  */
