/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__PCA_H__INCLUDED__)
#define __NDD__PCA_H__INCLUDED__

#include <ndd/defs.h>
#include <ndd/callback.h>

struct __ndd_pca
{
    void *dummy;
};

extern ndd_result ndd_pca_create (ndd_pca **pca);
extern ndd_result ndd_pca_destroy(ndd_pca **pca);

/*  src_matrix γ row ǡ column ץ  */
extern ndd_result ndd_pca_analyze(ndd_pca *pca,
				  ndd_matrix *dst_coef_matrix, ndd_vector *dst_lambda_vector,
				  const ndd_matrix *src_matrix,
				  ndd_callback callback, void *user_data);

#endif  /*  #if !defined(__NDD__PCA_H__INCLUDED__)  */

/*  end of file  */
