/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#if !defined(__NDD__SEARCH_H__INCLUDED__)
#define __NDD__SEARCH_H__INCLUDED__

#include <ndd/defs.h>
#include <ndd/callback.h>

typedef enum __ndd_search_merge_level
{
    ndd_search_merge_level_unknown = 0,
    ndd_search_merge_level_none,
    ndd_search_merge_level_line,
    ndd_search_merge_level_square,

    ndd_search_merge_level_default = ndd_search_merge_level_line

} ndd_search_merge_level;

extern ndd_result ndd_search(const ndd_sfd *sfd1, const ndd_ffd *ffd1, ndd_fvd *fvd1,
			     const ndd_sfd *sfd2, const ndd_ffd *ffd2, ndd_fvd *fvd2,
			     ndd_search_merge_level search_merge_level,
			     ndd_callback callback, void *user_data);

#endif  /*  #if !defined(__NDD__SEARCH_H__INCLUDED__)  */

/*  end of file  */
