/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <ndd/defs.h>
#include <ndd/answer.h>
#include <ndd/error.h>
#include <ndd/memory.h>

ndd_result
ndd_answer_create(ndd_answer **answer)
{
    NDD_START;
    NDD_VERIFY_POINTER(answer);

    ndd_answer *new_answer = NULL;
    NDD_VERIFY_RESULT(ndd_calloc(&new_answer, sizeof(ndd_answer)));

    NDD_IFOK{
	*answer = new_answer;
	new_answer = NULL;
    }

    if(new_answer != NULL){
	ndd_free(&new_answer);
    }

    NDD_RETURN;
}

ndd_result
ndd_answer_destroy(ndd_answer **answer)
{
    NDD_START;
    NDD_VERIFY_POINTER(answer);

    NDD_VERIFY_RESULT(ndd_free(answer));
    NDD_IFOK{
	*answer = NULL;
    }

    NDD_RETURN;
}

/*  end of file  */
