/*
    Copyright 2006-2009 Nagoya University

    This file is part of NDD (Near Duplicate Detector).

    NDD is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    NDD is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NDD.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <ndd/callback.h>
#include <ndd/error.h>

ndd_result
ndd_callback_default_handler(const char *process_name, const char *stage_name,
			     ndd_uint32 position, ndd_uint32 total, void *user_data)
{
    NDD_START;

    NDD_IFOK{
	if(stage_name == NULL){
	    fputs("\n", stdout);
	}else{
	    if(total > 0){
		fprintf(stdout, "\r%s: %s ... %.2f%%", process_name, stage_name, (double)position / (double)total * 100);
		fflush(stdout);
	    }else{
		fprintf(stdout, "\r%s: %s ... %lu", process_name, stage_name, position);
		fflush(stdout);
	    }
	}
    }

    NDD_RETURN;
}

/*  end of file  */
